------------------------------------------------------------------------------
-- MakeMeGetMyMain - Alarms you when something happens to your character
------------------------------------------------------------------------------
-- Trigger_Fatigue.lua - Triggerd on player death
--
-- Author: Expelliarm5s / January 2023 / All Rights Reserved
--
-- Version 1.1.24
------------------------------------------------------------------------------
-- luacheck: ignore 212 globals DLAPI UnitAura

local addonName, addon = ...
local modle = addon:NewModule("Fatigue", "AceEvent-3.0", "AceConsole-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale(addonName)
-- local private = {}
------------------------------------------------------------------------------

function modle:ModuleName()
	return modle.moduleName
end

function modle:ToggleMod()
	addon.db.global[modle.moduleName] = addon.db.global[modle.moduleName] or false
	addon.db.global[modle.moduleName] = not addon.db.global[modle.moduleName]
	if addon.db.global[modle.moduleName] then
		addon:Printf(L["Module %s enabled"], modle.moduleName)
	else
		addon:Printf(L["Module %s disabled"], modle.moduleName)
	end
end

function modle:EnableMod()
	addon.db.global[modle.moduleName] = true
	addon:Printf(L["Module %s enabled"], modle.moduleName)
end

function modle:DisableMod()
	addon.db.global[modle.moduleName] = false
	addon:Printf(L["Module %s disabled"], modle.moduleName)
end

function modle:Login()
	modle:RegisterEvent("PLAYER_DEAD")
end

function modle:ModuleIcon()
	if WOW_PROJECT_ID and WOW_PROJECT_ID == 2 then
		return "INTERFACE\\ICONS\\Temp"
	else
		return "INTERFACE\\ICONS\\TEMP"
	end
end

function modle:TriggerName()
	return L["Character fatigued!"]
end

function modle:TriggerDesc()
	return L["Alarm fires on character's fatigue."]
end

function modle:CheckAura()
	addon:DebugPrintf(modle.moduleName .. "~  %s", "CheckAura")
	for i=1, 40 do
		local name, icon, count, debuff, duration, expirationTime, source, isStealable, nameplate, spellId = UnitAura("player", i)

		addon:DebugPrintf(modle.moduleName .. "~ UnitAura(): name=%s, icon=%s, count=%s, type=%s, dur=%s, exp=%s, source=%s, steal=%s, id=%s",
			tostring(name), tostring(icon), tostring(count), tostring(debuff), tostring(duration),
			tostring(expirationTime), tostring(source), tostring(isStealable), tostring(nameplate), tostring(spellId))

		-- https://www.wowhead.com/spell=5/death-touch
		local aura = 5
		if spellId and spellId == aura then
			return true
		end
	end
end

function modle:PLAYER_DEAD(event)
	addon:DebugPrintf(modle.moduleName .. "~  %s", tostring(event))
	if event == "PLAYER_DEAD" then
		if addon.isEnabled and addon.db.global[modle.moduleName] then
			-- delayed check for the right aura
			C_Timer.After(1, function()
				if modle:CheckAura() then
					addon:DebugPrintf(modle.moduleName .. "~  -> GUI:Fire(%s)", modle.moduleName)
					addon:Printf("Module " .. modle.moduleName .. ": " .. modle:TriggerName())
					if addon.GUI.Fire then
						addon.GUI:Fire(modle.moduleName)
					end
				end
			end)
		end
	end
end

-- EOF